UIPackage
Menu

Framework

Change language

Boilerplate repo

Auth Password Reset

blockauth

Four-stage password reset surface in a single card: request (email form) -> sent (check-your-inbox confirmation with "Open reset form" demo button) -> reset (new password + confirm with match validation) -> done (success confirmation linking back to sign-in). Emits `request` (email) when the link is asked for and `reset` (password) when the new password is set; consumer wires the actual mail/db calls.

Also available for React ->

Installation

$npx shadcn-vue@latest add https://uipkge.dev/r/vue/auth-password-reset.json
Named registry:npx shadcn-vue@latest add @uipkge/auth-password-resetInstalls to:app/components/blocks/

Variants

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
signInHrefstring'/login'optional

npm dependencies

Files installed (1)

  • app/components/blocks/AuthPasswordReset.vue4.9 kB
    <script setup lang="ts">
    import { computed, ref } from 'vue'
    import { ArrowLeft, MailCheck } from 'lucide-vue-next'
    import { Card, CardContent, CardDescription, CardFooter, CardHeader, CardTitle } from '@/components/ui/card'
    import { Input } from '@/components/ui/input'
    import { Label } from '@/components/ui/label'
    import { Button } from '@/components/ui/button'
    
    withDefaults(
      defineProps<{
        signInHref?: string
      }>(),
      { signInHref: '/login' },
    )
    
    const emit = defineEmits<{
      (e: 'request', email: string): void
      (e: 'reset', password: string): void
    }>()
    
    type Stage = 'request' | 'sent' | 'reset' | 'done'
    const stage = ref<Stage>('request')
    
    const email = ref('')
    const password = ref('')
    const confirm = ref('')
    const passwordsMatch = computed(() => !confirm.value || password.value === confirm.value)
    
    function submitRequest() {
      if (!email.value) return
      emit('request', email.value)
      stage.value = 'sent'
    }
    
    function submitReset() {
      if (!password.value || !passwordsMatch.value) return
      emit('reset', password.value)
      stage.value = 'done'
    }
    </script>
    
    <template>
      <div data-slot="auth-password-reset" class="bg-background flex min-h-svh items-center justify-center p-6">
        <Card class="w-full max-w-sm">
          <template v-if="stage === 'request'">
            <CardHeader class="text-center">
              <CardTitle class="text-2xl">Forgot password?</CardTitle>
              <CardDescription>Enter your email and we'll send you a reset link.</CardDescription>
            </CardHeader>
            <CardContent>
              <form class="space-y-4" @submit.prevent="submitRequest">
                <div class="grid gap-2">
                  <Label for="reset-email">Email</Label>
                  <Input id="reset-email" v-model="email" type="email" placeholder="[email protected]" required />
                </div>
                <Button type="submit" class="w-full">Send reset link</Button>
              </form>
            </CardContent>
            <CardFooter class="justify-center">
              <a
                :href="signInHref"
                class="text-muted-foreground hover:text-foreground inline-flex items-center gap-1 text-sm"
              >
                <ArrowLeft class="size-3" />Back to sign in
              </a>
            </CardFooter>
          </template>
    
          <template v-else-if="stage === 'sent'">
            <CardContent class="space-y-4 pt-6 text-center">
              <div class="bg-primary/10 text-primary mx-auto flex size-12 items-center justify-center rounded-full">
                <MailCheck class="size-6" />
              </div>
              <div class="space-y-1">
                <h3 class="text-lg font-semibold">Check your inbox</h3>
                <p class="text-muted-foreground text-sm">
                  We've sent a reset link to <span class="text-foreground font-medium">{{ email }}</span
                  >.
                </p>
              </div>
              <Button variant="outline" class="w-full" @click="stage = 'reset'">Open reset form (demo)</Button>
              <button
                class="text-muted-foreground hover:text-foreground text-xs underline-offset-4 hover:underline"
                @click="stage = 'request'"
              >
                Wrong email?
              </button>
            </CardContent>
          </template>
    
          <template v-else-if="stage === 'reset'">
            <CardHeader class="text-center">
              <CardTitle class="text-2xl">Set new password</CardTitle>
              <CardDescription>Pick a strong password you haven't used before.</CardDescription>
            </CardHeader>
            <CardContent>
              <form class="space-y-4" @submit.prevent="submitReset">
                <div class="grid gap-2">
                  <Label for="reset-pw">New password</Label>
                  <Input id="reset-pw" v-model="password" type="password" autocomplete="new-password" required />
                </div>
                <div class="grid gap-2">
                  <Label for="reset-confirm">Confirm password</Label>
                  <Input
                    id="reset-confirm"
                    v-model="confirm"
                    type="password"
                    autocomplete="new-password"
                    :aria-invalid="!passwordsMatch"
                    required
                  />
                  <p v-if="!passwordsMatch" class="text-destructive text-xs">Passwords don't match.</p>
                </div>
                <Button type="submit" class="w-full">Reset password</Button>
              </form>
            </CardContent>
          </template>
    
          <template v-else>
            <CardContent class="space-y-4 pt-6 text-center">
              <div class="bg-success/10 text-success mx-auto flex size-12 items-center justify-center rounded-full">
                <MailCheck class="size-6" />
              </div>
              <div class="space-y-1">
                <h3 class="text-lg font-semibold">All set</h3>
                <p class="text-muted-foreground text-sm">
                  Your password has been updated. You can now sign in with the new password.
                </p>
              </div>
              <a :href="signInHref"><Button class="w-full">Continue to sign in</Button></a>
            </CardContent>
          </template>
        </Card>
      </div>
    </template>
    

Raw manifest:https://uipkge.dev/r/vue/auth-password-reset.json

UIPackage
Menu

Framework

Change language

Boilerplate repo

Auth Password Reset

blockauth

Four-stage password reset surface in a single card: request (email form) -> sent (check-your-inbox confirmation with "Open reset form" demo button) -> reset (new password + confirm with match validation) -> done (success confirmation linking back to sign-in). Emits `request` (email) when the link is asked for and `reset` (password) when the new password is set; consumer wires the actual mail/db calls.

Also available for Vue ->

Installation

$npx shadcn@latest add https://uipkge.dev/r/react/auth-password-reset.json
Named registry:npx shadcn@latest add @uipkge-react/auth-password-resetInstalls to:components/blocks/

Variants

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
signInHrefstringoptional
onRequest(email: string) => voidoptional
onReset(password: string) => voidoptional

npm dependencies

Files installed (1)

  • components/blocks/AuthPasswordReset.tsx6 kB
    'use client'
    
    import * as React from 'react'
    import { ArrowLeft, MailCheck } from 'lucide-react'
    import { Card, CardContent, CardDescription, CardFooter, CardHeader, CardTitle } from '@/components/ui/card'
    import { Input } from '@/components/ui/input'
    import { Label } from '@/components/ui/label'
    import { Button } from '@/components/ui/button'
    
    type Stage = 'request' | 'sent' | 'reset' | 'done'
    
    export interface AuthPasswordResetProps {
      signInHref?: string
      onRequest?: (email: string) => void
      onReset?: (password: string) => void
    }
    
    export function AuthPasswordReset({ signInHref = '/login', onRequest, onReset }: AuthPasswordResetProps) {
      const [stage, setStage] = React.useState<Stage>('request')
    
      const [email, setEmail] = React.useState('')
      const [password, setPassword] = React.useState('')
      const [confirm, setConfirm] = React.useState('')
      const passwordsMatch = !confirm || password === confirm
    
      function submitRequest(e: React.FormEvent) {
        e.preventDefault()
        if (!email) return
        onRequest?.(email)
        setStage('sent')
      }
    
      function submitReset(e: React.FormEvent) {
        e.preventDefault()
        if (!password || !passwordsMatch) return
        onReset?.(password)
        setStage('done')
      }
    
      return (
        <div data-slot="auth-password-reset" className="bg-background flex min-h-svh items-center justify-center p-6">
          <Card className="w-full max-w-sm">
            {stage === 'request' && (
              <>
                <CardHeader className="text-center">
                  <CardTitle className="text-2xl">Forgot password?</CardTitle>
                  <CardDescription>Enter your email and we&apos;ll send you a reset link.</CardDescription>
                </CardHeader>
                <CardContent>
                  <form className="space-y-4" onSubmit={submitRequest}>
                    <div className="grid gap-2">
                      <Label htmlFor="reset-email">Email</Label>
                      <Input
                        id="reset-email"
                        value={email}
                        onChange={(e) => setEmail(e.target.value)}
                        type="email"
                        placeholder="[email protected]"
                        required
                      />
                    </div>
                    <Button type="submit" className="w-full">
                      Send reset link
                    </Button>
                  </form>
                </CardContent>
                <CardFooter className="justify-center">
                  <a
                    href={signInHref}
                    className="text-muted-foreground hover:text-foreground inline-flex items-center gap-1 text-sm"
                  >
                    <ArrowLeft className="size-3" />
                    Back to sign in
                  </a>
                </CardFooter>
              </>
            )}
    
            {stage === 'sent' && (
              <CardContent className="space-y-4 pt-6 text-center">
                <div className="bg-primary/10 text-primary mx-auto flex size-12 items-center justify-center rounded-full">
                  <MailCheck className="size-6" />
                </div>
                <div className="space-y-1">
                  <h3 className="text-lg font-semibold">Check your inbox</h3>
                  <p className="text-muted-foreground text-sm">
                    We&apos;ve sent a reset link to <span className="text-foreground font-medium">{email}</span>.
                  </p>
                </div>
                <Button variant="outline" className="w-full" onClick={() => setStage('reset')}>
                  Open reset form (demo)
                </Button>
                <button
                  className="text-muted-foreground hover:text-foreground text-xs underline-offset-4 hover:underline"
                  onClick={() => setStage('request')}
                >
                  Wrong email?
                </button>
              </CardContent>
            )}
    
            {stage === 'reset' && (
              <>
                <CardHeader className="text-center">
                  <CardTitle className="text-2xl">Set new password</CardTitle>
                  <CardDescription>Pick a strong password you haven&apos;t used before.</CardDescription>
                </CardHeader>
                <CardContent>
                  <form className="space-y-4" onSubmit={submitReset}>
                    <div className="grid gap-2">
                      <Label htmlFor="reset-pw">New password</Label>
                      <Input
                        id="reset-pw"
                        value={password}
                        onChange={(e) => setPassword(e.target.value)}
                        type="password"
                        autoComplete="new-password"
                        required
                      />
                    </div>
                    <div className="grid gap-2">
                      <Label htmlFor="reset-confirm">Confirm password</Label>
                      <Input
                        id="reset-confirm"
                        value={confirm}
                        onChange={(e) => setConfirm(e.target.value)}
                        type="password"
                        autoComplete="new-password"
                        aria-invalid={!passwordsMatch}
                        required
                      />
                      {!passwordsMatch && <p className="text-destructive text-xs">Passwords don&apos;t match.</p>}
                    </div>
                    <Button type="submit" className="w-full">
                      Reset password
                    </Button>
                  </form>
                </CardContent>
              </>
            )}
    
            {stage === 'done' && (
              <CardContent className="space-y-4 pt-6 text-center">
                <div className="bg-success/10 text-success mx-auto flex size-12 items-center justify-center rounded-full">
                  <MailCheck className="size-6" />
                </div>
                <div className="space-y-1">
                  <h3 className="text-lg font-semibold">All set</h3>
                  <p className="text-muted-foreground text-sm">
                    Your password has been updated. You can now sign in with the new password.
                  </p>
                </div>
                <a href={signInHref}>
                  <Button className="w-full">Continue to sign in</Button>
                </a>
              </CardContent>
            )}
          </Card>
        </div>
      )
    }
    

Raw manifest:https://uipkge.dev/r/react/auth-password-reset.json